Robo2.Log("Script: " + SCRIPT_FILE)

Robo2.SetAmplifierCoefficients(1000, 100);
Robo2.SetSampleRate(5000);
Robo2.SetControlSampleRate(50);

for (var i = 0; i < Robo2.SelectedWells.Count; i++)
{
	var WellIndex = Robo2.SelectedWells[i];

	Robo2.Log("Recording oocyte in well: " + Robo2.SelectedWellNames[i]);
	Robo2.MoveToWell(WellIndex);
	
	Robo2.ZMoveToLiquid();
	Robo2.ZMoveToOocyte();
	
	Robo2.Log("Current clamp at 0 nA");
	Robo2.SetHoldingCurrent(0);
	Robo2.SetCurrentClamp();
	
	Robo2.Log("Voltage clamp mode at -40 mV");
	Robo2.SetHoldingVoltage(-40);
	Robo2.SetVoltageClamp();
	
	Robo2.Log("Starting Control Recording");
	Robo2.StartControlRecording()
	Robo2.Wait(5);
	Robo2.StopControlRecording()
	
	Robo2.Wait(2);
	
	RecDisplay.Clear();
	RecDisplay.TrackYMin(true);
	RecDisplay.TrackYMax(true);
	
	Robo2.Log("Starting Recording");
	RecDisplay.SetXAxis(0, 5);
	Robo2.StartRecording()
	Robo2.Wait(5);
	Robo2.StopRecording()
	
	Robo2.Wait(2);
	
	RecDisplay.Clear();
		
	Robo2.Log("Starting IV-Protocol");	
	Robo2.RecordIVProtocol("Script-Test");
	RecDisplay.ZoomToFitX();
	
}

