Robo2.Log("Script: " + SCRIPT_FILE)


Set_MIN_RMP(15); // positive value here to enable testing with TMC connected...
Set_DCOFFSET_RANGE(20); 
		
// Start of Oocyte loop
// ----------------------------------------------

for (var i = 0; i < Robo2.SelectedWells.Count; i++)
{
	var WellIndex = Robo2.SelectedWells[i];

	// Measuring head moves to selected well
	
	Robo2.Log("");
	Robo2.Log("Recording oocyte in well: " + Robo2.SelectedWellNames[i]);
	
	Robo2.MoveToWell(WellIndex);
	//Robo2.WastePumpOn(10000);
	Robo2.ZMoveToLiquid();
	Robo2.Wait(2);	
	
	// Setting of axis scalings 
		
	ControlDisplay.SetXAxis(0, 30);
	ControlDisplay.SetYAxis_U(-100, 10);
	ControlDisplay.SetYAxis_I(-30, 30);

	// Starting Current Clamp mode
	
	Robo2.Log("Current clamp at 0 nA");
	Robo2.SetHoldingCurrent(0);
	Robo2.SetCurrentClamp();

	// Starting Control Recording for electrode offset reset and resistance test
	
	Robo2.StartControlRecording();

	// Electrode offset reset            
	Robo2.Log("Elektrode reset ...");

	if (!Robo2.DCOffsetCorrection(DCOFFSET_RANGE, DCOFFSET_DELAY, DCOFFSET_WAIT, DCOFFSET_ATTEMPTS))
	{
		continue;
	}

	// Electrode resistance test
		
	if (Robo2.ResistanceCheck_I(MIN_RESISTANCE_I, MAX_RESISTANCE_I))
	{
	}
	else
	{Robo2.StopControlRecording();
		continue;
	}

	if (Robo2.ResistanceCheck_U(MIN_RESISTANCE_U, MAX_RESISTANCE_U))
	{
	}
	else
	{Robo2.StopControlRecording();
		continue;
	}

	Robo2.StopControlRecording();

	// Impalement procedure

	Robo2.Log("Starting Oocyte Impalement...");
		
	Robo2.StartControlRecording();
	
	Robo2.Wait(2);
		
	if (!Robo2.Impale(MIN_RMP, IMPALEMENT_STEPS, IMPALEMENT_STEP, IMPALEMENT_WAIT))
	{
		Robo2.Log("impalement failed, " + MIN_RMP + " not reached --> next oocyte");
		//Robo2.ValvePumpOff();
		//Robo2.CloseAllValves();
		//Robo2.WastePumpOff();
		continue;
	}
	
	Robo2.StopControlRecording();

	// Starting Voltage Clamp and leak current check routine
	
	Robo2.Log("Voltage clamp ...");
	
	ControlDisplay.SetXAxis(0, 60)
	ControlDisplay.SetYAxis_U(-40, -20)
	ControlDisplay.SetYAxis_I(MIN_INITIAL_LEAKCURRENT, MAX_INITIAL_LEAKCURRENT)
	
	Robo2.SetHoldingVoltage(-30);
	Robo2.SetVoltageClamp();
	
	Robo2.Log("Initial leak current check (maximum = " + MIN_INITIAL_LEAKCURRENT + " nA) ...");
	
	Robo2.StartControlRecording();
	Robo2.Wait(1);

	if (!Robo2.InitialLeakCurrentCheck(MIN_INITIAL_LEAKCURRENT, MAX_INITIAL_LEAKCURRENT))
	{
		Robo2.Log("Proceeding with next oocyte");
		//Robo2.ValvePumpOff();
		//Robo2.CloseAllValves();
		//Robo2.WastePumpOff();
		continue;
	}

	// Script continues here if Initial Leak current was ok
	
	ControlDisplay.SetYAxis_I(MIN_LEAKCURRENT, MAX_LEAKCURRENT)

	// Starting Final Leak Current Check with perfusion
	
		
	Robo2.Log("Final leak current check (maximum = " + MIN_LEAKCURRENT + " nA) ...");
	
	if (!Robo2.LeakCurrentCheck(MIN_LEAKCURRENT, MAX_LEAKCURRENT, LEAKCURRENT_ATTEMPTS, LEAKCURRENT_WAIT))
	{
		Robo2.Log("leak current not in range");
		//Robo2.ValvePumpOff();
		//Robo2.CloseAllValves();
		//Robo2.WastePumpOff();
		continue;
	}
	
	Robo2.StopControlRecording();

	// Script continues here if Final Leak current was ok
	
	Robo2.Log("Start Recording in well " + Robo2.SelectedWellNames[i] + " for 5 s" );
	
	Robo2.StartRecording();
	Robo2.Wait(5);
	Robo2.StopRecording();
	
	Robo2.Wait(2);
	Robo2.RecordIVProtocol("tmc-test");
	Robo2.Wait(2);
	
}	

Robo2.Log("Recording protocol completed.");
Robo2.MoveToHomePos();
