// JavaScript_Example.js
// Roboocyte2 test script
// JavaScript example

// this file shows some basic JavaScript:
// - variables
// - arithmetic / comparison operators
// - if / else 
// - loops
// - arrays
// - functions

// ---- variables ----

// variables can be of type string, integer (whole number) or double (floating point number)
// declaration of string variable
var s = "Hello Roboocyte2"
Robo2.Log(s);

// declaration of integer variable
var x = 2 + 2;	// x is 4
// the integer value gets converted automatically to the equivalent string:
Robo2.Log("Test, x = " + x);

// declaration of floating point variable
var d = 3.1;
Robo2.Log(d);

// ---- arithmetic operators: +, -, *, / for int and double variable types ----
var x2 = x / 2;
Robo2.Log("x2 = " + x2);	// prints x2 = 2

// parentheses for arithmetic expressions, like in mathematics
var xx = 2;
var yy = 10;

var zz1 = xx * (2 + yy);	// zz1 is 24
var zz2 = xx * 2 + yy;		// zz2 is 40

// operator + for strings concatenates
var combined = "Hello" + " " + "Roboocyte2";
Robo2.Log(combined);

// ---- strings ----

var s1 = "up";
var s2 = "date"
var s3 = s1 + s2;
Robo2.Log("Length of " + s3 + " (s3): " + s3.length);	// prints Length of update (s3): 6
Robo2.Log("third character is: " + s3[2]);  // prints third character is: d
Robo2.Log("Substring: " + s3.substring(1, 3));  // prints Substring: pd

var s4 = "a:b:cde:fg:h";
var sSplit = s4.split(":");
Robo2.Log(sSplit.toString());  // prints a,b,cde,fg,h

Robo2.Log("splitted array:");
for (var l = 0; l < sSplit.length; l++)
{
	Robo2.Log(sSplit[l]);
}

Robo2.Log("Index of :cde in s4 is " + s4.indexOf(":cde"));	// prints Index of :cde in s4 is 3

var s5 = s1.concat(s2, s3);
Robo2.Log("Concat: " + s5);  // prints Concat: updateupdate

// ---- if construct ----

// (the else branch is optional)
// comparison operators are : >, >=, <, <=, ==, !=
var x = 2 + 2;
if (x > 4)
{
	// this should not be true
	Robo2.Log("x is > 4");
}
else
{
	Robo2.Log("x is <= 4");
}

if (x == 4)
{
	Robo2.Log("x is 4");
}

// ---- loops ----

// for loop (number of iterations known without depending on a variable)
for (var i = 0; i < 5; i++)
{
	Robo2.Log("Loop: " + i);
}

// loop can be interrupted via break or continue
for (var i = 0; i < 5; i++)
{
	Robo2.Log("Loop with break: " + i);
	if (i > 2)
	{
		break;
	}
}

for (var i = 0; i < 5; i++)
{
	Robo2.Log("Loop with continue: " + i);
	continue;
	// this is never called
	Robo2.Log("this is not called");
}

// while loop: number of iterations set by a variable
var j = 1; 
var i = 1; 
do { 
	i = i + 1; 
	j = j + 1; 
	if(j == 5) 
		break; 
} while(i < 10); 

// j == 5
Robo2.Log("After while loop, j = " + j);

// ---- arrays ----

var testVar = 123;
var TestArray1 = new Array('Hello', testVar, 3.14159);
Robo2.Log("First: " + TestArray1[0] + ", Second: " + TestArray1[1]); // prints First: Hello, Second: 123

TestArray1[3] = "fourth value";

Robo2.Log(TestArray1.toString());  // prints Hello,123,3.14159,fourth value

var TestArray2 = [1, 2, 3, 4];

var JoinedArrayString = TestArray2.join("+");
Robo2.Log("Joined Array:" + JoinedArrayString);	// prints 1+2+3+4
	
// set value at tenth index, values at index 4 to 8 are undefined
TestArray2[9] = 5;

Robo2.Log("length of TestArray2: " + TestArray2.length);  // length is 10

TestArray2.push(6);

Robo2.Log(TestArray2.toString()); // prints 1,2,3,4,,,,,,5,6

var x = TestArray2.pop();
Robo2.Log("last value was: " + x);
Robo2.Log(TestArray2.toString()); // prints 1,2,3,4,,,,,,5

TestArray2.shift();
Robo2.Log(TestArray2.toString()); // prints 2,3,4,,,,,,5

var TwoDArray = new Array();
var row1 = [1, 2, 3];
var row2 = [4, 5, 6];
var row3 = [7, 8, 9];

TwoDArray[0] = row1;
TwoDArray[1] = row2;
TwoDArray[2] = row3;
Robo2.Log(TwoDArray[1].toString());  // prints 4,5,6

// ---- functions ----
// function example, functions can have 0 or more parameters and 0 or one return value
// function definitions

// example 1: no parameter, no return value
function printHello()
{
	Robo2.Log("Hello");
}

// example 2: one parameter and return value
function square(x) {
	return x * x;
}

// example 3: two parameters and return value
function multiplyAndLog(x, y) {
	var result = x * y;
	Robo2.Log("Multiplying " + x + " by " + y + " equals " + result);
	return result;
}

// now calling the functions (executing the function code with the actual values os the parameters)

// call function by using the function name and parenthesis
printHello();  // print Hello

var value = 2;
var squared = square(value);
Robo2.Log("squared = " + squared);	// prints 4

value = 123456;
var squared = square(value);
Robo2.Log("squared = " + squared);	// prints 15241383936

var value10 = multiplyAndLog(2, 5);


