	// --------------------------------------------------------------------
	// Expression test
	// --------------------------------------------------------------------
	
	Robo2.SetDialogVariable("pre_pulse_ms", 100, "Prepulse for expression test (ms)");
	Robo2.SetDialogVariable("pulse_ms", 200, "Pulse duration for expression test (ms)");
	Robo2.SetDialogVariable("post_pulse_ms", 200, "Post-pulse duration for expression test (ms)");
	
	Robo2.SetDialogVariable("voltage_rest", -60, "Resting Voltage for expression test (mV)");
	Robo2.SetDialogVariable("voltage_et", 50, "Activating Voltage for expression test (mV)");
	
	RecDisplay.SetXAxisMilliSec(0, pre_pulse_ms + pulse_ms + post_pulse_ms);
	RecDisplay.TrackYMax(true);
	RecDisplay.TrackYMin(true);
	
	Robo2.SetAnalysisROIMilliSec(pre_pulse_ms + 10, pre_pulse_ms + pulse_ms);
	
	Robo2.Log("Starting expression test with voltage jump to " + voltage_et + " ");
	
	// Test Voltage Step
	
	Robo2.SetHoldingVoltage(voltage_rest);
	Robo2.SetVoltageClamp();
	
	Robo2.StartRecording();
	Robo2.TransmitRecording(REC_TAG_REF_VOLTAGE);
	Robo2.TransmitVoltage(voltage_et);
	
	Robo2.WaitMilliSec(100);
	
	Robo2.SetHoldingVoltage(voltage_et);
	Robo2.WaitMilliSec(200);
	
	Robo2.SetHoldingVoltage(voltage_rest);
	Robo2.WaitMilliSec(200);
	
	Robo2.StopRecording();
	
	Robo2.Log(" ");
	signal = Robo2.MAXIMUM
	Robo2.Log("Response to reference voltage pulse to " + voltage_et + " mV = " + signal + " nA");
	Robo2.Log(" ");
			
	/// Comparing response with user defined minimum rsponse 
	
	if (signal < minResponse || signal > maxResponse)
	{
		Robo2.Log("Response (" + signal + " nA) not in Range (" + minResponse + ", " + maxResponse + "), go to next oocyte");
		Robo2.Wait(2);
		
		Robo2.ValvePumpOff();
		Robo2.CloseAllValves();
		Robo2.WastePumpOff();
		continue;
	}
