Robo2.Log("Script: " + SCRIPT_FILE)

Robo2.SetAmplifierCoefficients(1000, 100);
Robo2.SetSampleRate(1000);
Robo2.SetControlSampleRate(50);

for (var i = 0; i < Robo2.SelectedWells.Count; i++)
{
	var WellIndex = Robo2.SelectedWells[i];

	Robo2.Log("Recording oocyte in well: " + Robo2.SelectedWellNames[i]);
	Robo2.MoveToWell(WellIndex);
	
	//Robo2.WastePumpOn(1000);
	
	Robo2.ZMoveToLiquid();
	Robo2.ZMoveToOocyte();
	
	Robo2.Log("Voltage clamp mode at -40 mV");
	Robo2.SetHoldingVoltage(-40);
	Robo2.SetVoltageClamp();
	
	
	ControlDisplay.SetXAxis(0, 5);
	
	ControlDisplay.TrackYMax(true);
	ControlDisplay.TrackYMin(true);
	
	Robo2.StartControlRecording();
	Robo2.Wait(5);
	Robo2.StopControlRecording();
	
	//Robo2.OpenValve(1);
	
	RecDisplay.SetXAxis(0, 9);
	RecDisplay.TrackYMax(true);
	RecDisplay.TrackYMin(true);
	Robo2.SetBaselineROI(0, 2);
	Robo2.SetAnalysisROI(3, 6);
	
	ControlDisplay.SetXAxis(0, 9)
	ControlDisplay.SetYAxis_I(-10000, 100)

	// Application of reference compound
	
	Robo2.StartRecording();
	Robo2.TransmitRecording(REC_TAG_REF_COMPOUND);
	Robo2.TransmitCompoundValve(2);
	Robo2.Wait(3);
	//Robo2.OpenValve(2);
	Robo2.Wait(3);
	//Robo2.OpenValve(1);
	Robo2.Wait(3);
	Robo2.StopRecording();
	
	RecDisplay.Clear();
	
	// --------------------------------------------------------------------
	// Start of Dose-Response protocol-----------------------------------------
	// --------------------------------------------------------------------
	
	Robo2.Log("Starting dose response curve with liquids in valves 2 to 8");
	
	ControlDisplay.SetXAxis(0, 9)
	
	RecDisplay.SetXAxis(0, 9);
	RecDisplay.TrackYMax(true);
	RecDisplay.TrackYMin(true);
	Robo2.SetBaselineROI(0, 2);
	Robo2.SetAnalysisROI(3, 6);
	
	
	for (var valve = 2; valve <= 8; valve++)
		
	{	
				
		Robo2.StartRecording();
		Robo2.Wait(3);
		//Robo2.OpenValve(valve);
		Robo2.TransmitRecording(REC_TAG_COMPOUND)
		Robo2.TransmitCompoundValve(valve);
		Robo2.Wait(3);
		//Robo2.OpenValve(1);
		Robo2.Wait(3);
		Robo2.StopRecording();
		
		RecDisplay.Clear();
				
	}
	
	//Robo2.ValvePumpOff();
	//Robo2.CloseAllValves();
	//Robo2.WastePumpOff();
}

// -----------------------------------------------------------------------------------------------------
// End of Oocyte Loop ----------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------

// Cleaning up

//Robo2.ValvePumpOff();
//Robo2.CloseAllValves();
//Robo2.WastePumpOff();
Robo2.Log("Recording protocol completed.");
Robo2.MoveToHomePos();

